// tsap112.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "conio.h"
#include "stdio.h"
#include "stdlib.h"
#include "windows.h"
#include "sys/timeb.h"

#include "AP112ioctl.h" //ap110 self include
#include <winioctl.h>

//Ӧʽö̬ӿ
#pragma comment(lib,"AP112.lib")
#include "AP112.h"

HANDLE hDevice;

//function declare
void tsio();
void tscnt();
void tsad();
void tsda();

//sub function
int sort(int v[],int n)   //ѡ񷨱ȽϴС
{
	int i,j,k,t;
	for(i=0;i<n-1;i++)
	{
		k=i;
		for(j=i+1;j<n;j++)
			if(v[j]>v[k])k=j;
			t=v[k];v[k]=v[i];v[i]=t;
	}
	
	return 0;
}


int main(int argc, char* argv[])
{
	long i=0;
	printf("testing ap112...................wwlab (c) 2012.2.\n");

	hDevice=AP112_OpenDevice(0);

	if(hDevice==INVALID_HANDLE_VALUE)
	{
		printf("error to open AP112's Device or Hardware!\n");
		getch();
		Beep(1000,300);
		exit(0);
	}
	printf("OK!Open Device=%xh\n",hDevice);

	do
	{
		printf("1.IO test.\n2.AD test.\n3.DA test.\n4.CNT test.\n");
		printf("please input test NO.\n");

		printf("ESC to end.\n");

		i=getch();

		switch(i)
		{
		case '1':tsio();break;
		case '2':tsad();break;
		case '3':tsda();break;
		case '4':tscnt();break;
		}		
	}while(i!=27);

	AP112_CloseDevice(hDevice);

	return 0;
}



//io test
void tsio()
{
	long i,j;

	printf("**********************testing io**********************\n");

	AP112_DO(hDevice,0x55aa);
	j=AP112_DI(hDevice);
	printf("%x\n",j);

	if(j==0x55aa)
	{
		printf("io test is ok!\n");
	}
	else
	{
		printf("error!\n");
	}

	//i=getch();
	Sleep(1000);

	AP112_DO(hDevice,0xaa55);
	j=AP112_DI(hDevice);
	printf("%x\n",j);

	if(j==0xaa55)
	{
		printf("io test is ok!\n");
		Sleep(1000);
		AP112_DO(hDevice,0x0);
	}
	else
	{
		printf("error!\n");
	}

	printf("press any key to continue.\n");

	i=getch();
}

//cnt test
void tscnt()
{
	printf("testing cnt......\n");
	__int32 cwd[2];

	__int32 crd0,crd1;//read data
	__int32 trd0,trd1;//read data

	//long crd0,crd1;//read data
	//long trd0,trd1;//read data

	//long cntch=0;
	__int32 cntch=0;

	cwd[0]=1100;//ini cnt0
	cwd[1]=1000;//ini cnt1

	for(cntch=0;cntch<2;cntch++)
	{
		printf("ini ch=%d    data=%d....\n",cntch,cwd[cntch]);
		AP112_CNT_Run(hDevice,cntch,cwd[cntch]);
	}

	printf("return of read %d......%d\n",AP112_CNT_Read(hDevice,0,&crd0,&trd0),AP112_CNT_Read(hDevice,1,&crd1,&trd1));
	printf("read cntch=%d    cntch=%d    timer0=%d    timer1=%d\n",crd0,crd1,trd0,trd1);


	printf("press any key to continue.\n");

	getch();

	int j;
	j=1001;

	printf("gen %d pulse....\n",j);

	int i;
	for(i=0;i<j;i++)
	{
		AP112_DO(hDevice,0xc000);
		AP112_DO(hDevice,0x0);
	}

	printf("return of read %d......%d\n",AP112_CNT_Read(hDevice,0,&crd0,&trd0),AP112_CNT_Read(hDevice,1,&crd1,&trd1));
	printf("read cntch0=%d    cntch1=%d    timer0=%d    timer1=%d\n",crd0,crd1,trd0,trd1);
}

//ad not cal , ch0 voltage
void tsad()
{
	//long maxv=0.0,minv=0.0,averv=0.0;
	//gain=0  0-5v
	int i,j;
	long max,min,error,aver;
	int v[500];
	long k=0;
	int gain=0;
	int sidi=0;
	int ch=0x0;//cz
	double vv;

	//i=0;

	printf("---------------testing AD---------------\n");

	do
	{
		for(j=0;j<500;j++)
		{
			v[j]=AP112_AD(hDevice,ch,gain,sidi,10);
			k+=v[j];
		}

		sort(v,500);

		max=v[0];
		min=v[499];
		error=max-min;
		aver=k/500;
		vv=AP112_ADV(gain,aver);

		printf("   MAX     MIN      ERROR     AVER      VV(mv)\n");

		printf("   %5d    %5d    %5d      %5d      %5.1f\n",max,min,error,aver,vv);

		printf("press g to change gain.\n");
		printf("press ESC to quit ad test.\n");

		i=getch();

		if(i=='g')
		{
			gain++;
			gain=(gain>2)?0:gain;
			k=0;
		}

		Sleep(1);

		k=0;//λ
		
	}while(i!=27);

	printf("\n");
}


//test da
void tsda()
{
	long j;
	int dach;
	int dagain;
	int dadata;

	dach=0;
	dagain=0;

	long ch;
	long adg;
	long sidi;
	long naver;

	naver=1000;
	sidi=1;

	int i;

	printf("---------------testing DA---------------\n");

	do
	{
		printf("please input dach:");
		scanf("%d",&dach);
		printf("please input dag:");
		scanf("%d",&dagain);
		printf("please input dadata:");
		scanf("%d",&dadata);

		AP112_DA(hDevice,dach,dagain,dadata);

		Sleep(1);

		ch=(dach==0)?0xe:ch;
		ch=(dach==1)?0xf:ch;

		adg=(dagain==0)?1:adg;
		adg=(dagain==1)?2:adg;

		Sleep(1000);

		j=AP112_AD(hDevice,ch,adg,sidi,naver);
		j=(j>>4) & 0xfff;

		Sleep(100);

		printf("%d\n",j);

		printf("press ESC to quit ad test.\n");
		printf("press any key to continue.\n");

		i=getch();
	}while(i!=27);
}