#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <graph.h>
#include <sys/timeb.h>
#include<sys/types.h>
#include <math.h>

#include "AP112.h"

//must be for AP112

struct timeb st,et;
long delay1ms;

//www.wwlab.com.cn
//2011.12

//iobase
long hDevice=0x320;

//16 bit ad
#define ad_unif 65535
#define ad_bipf 32768

void main()
{
	long i,j;

	_clearscreen(_GCLEARSCREEN);
	printf("The AP112 testing program wwlab (c) 2011.12.\n");
	//find AP112
	printf("please set AP112's address 0x320......\n");

	printf("Press any key to continue.\n");

	delay_data();

	//menu
	do
	{
		printf("1.AD test.\n2.DA test.\n0.exit.\n");
		printf("Please input your sel.....\n");
		i=getch();

		switch(i)
		{
			case '1':
			tsad();break;
			case '2':
			tsda();break;
			default:
			break;
		}
	}while(i!='0');
}

//*****************************sub function**************************
//da test
tsda()
{
	int i,j,k;
	
	printf("******************************************\n");
	printf("DA=0-10V,dach=0,set da out = 0-10V\n");

	printf("da=0v\n");
	AP112_DA(hDevice,0,0,0x0);
	i=getch();

	printf("da=10v\n");
	AP112_DA(hDevice,0,0,0xfff);
	i=getch();

	printf("da=5v\n");
	AP112_DA(hDevice,0,0,0x800);
	i=getch();
	
	printf("******************************************\n");
	printf("DA=-10V-+10V,dach=0,set da out = +/-10V\n");

	printf("da=0v\n");
	AP112_DA(hDevice,0,1,0x7ff);
	i=getch();

	printf("da=10v\n");
	AP112_DA(hDevice,0,1,0xfff);
	i=getch();

	printf("da=-10v\n");
	AP112_DA(hDevice,0,1,0x0);
	i=getch();
}

//da function
long AP112_DA(long hDevice,long dach,long dag,long dadata)
{
	long i;
	//15-14:dag
	//13-12:dach
	//11-0:dadata
	i=dadata & 0xfff;//12bit data
	dach=dach & 0x3;
	dag=dag & 0x3;

	i=i | (dach << 12);
	i=i | (dag << 14);

	AP112_outb(hDevice,0x2,i & 0xff);
	AP112_outb(hDevice,0x3,(i >> 8) & 0xff);
}

//ad test
tsad()
{
	int i;
	int stch,endch;
	long data;
	float u5,u10,bu10;
	int adg=0;

	printf("input start channel(0-15):");
	scanf("%d",&stch);
	stch=stch & 0xf;

	printf("input end channel(0-15):");
	scanf("%d",&endch);
	endch=endch & 0xf;

	do
	{
		//_settextposition(3,1);
		printf("ad gain=%d    st.ch=%d    end.ch=%d\n",adg,stch,endch);
		printf("_____________________________________________________________\n");
		printf("CH    data     5V       10V     +/-10V\n");

		for(i=stch;i<=endch;i++)
		{
			data=AP112_sam(hDevice,i,adg,0);

			if(i==0)
			{
				data=AP112_AD(hDevice,i,adg,0,100);//100 aver
			}
			
			//convert to voltage
			u5=AP112_ADV(0,data);
			u10=AP112_ADV(1,data);
			bu10=AP112_ADV(2,data);

			//_settextposition(i+6,1);
	    		printf("%2d  ",i);
			printf("%4ld     ",data);
			printf("%5.1f    ",u5);
			printf("%5.1f    ",u10);
			printf("%5.1f\n",bu10);
		}

		//_settextposition(24,1);
		printf("ESC to quit, g/G to change gain\n");

		// delay 0.1S for display speed
		dl();

		i=getch();

		if((i=='g') | (i=='G'))
		{
			adg++;
			adg=(adg>3)?0:adg;
		}
	}while(i!=27);
}

//ad sub function
//ad channel set
long AP112_ch(long xch,long gain,long sidi)
{
	long ch=0;

	sidi=sidi & 1;

	//ch
	ch=xch & 0xf;
	gain=gain & 0x3;

	ch=ch | (sidi << 7);
	ch=ch | (gain << 5);

	return ch;
}

//ad sam
long AP112_sam(long hDevice,long xch,long gain,long sidi)
{
	long i,j,k;
	long ch;

	ch=AP112_ch(xch,gain,sidi);

	//set channel
	AP112_outb(hDevice,0x0,(ch & 0xff));

	//delay and ad sam
	for(j=0;j<3;j++)
	{
		//run
		AP112_inb(hDevice,0x1);
		//if end
		do
		{
			i=AP112_inb(hDevice,0x0) & 1;
		}while(i!=0);
	}

	//read data
	k=(AP112_inb(hDevice,0x2)) | ((AP112_inb(hDevice,0x3) << 8));
	return k;
}

//ad sample aver
long AP112_AD(long hDevice,long ch,long gain,long sidi,long naver)
{
	long i=0;
	long aver=0;

	for(i=0;i<naver;i++)
		aver+=AP112_sam(hDevice,ch,gain,sidi);

	return (aver/naver);
}

//ad voltage calculate
long AP112_ADV(long adg,long addata)
{
	//double aa=0.0;
	float aa=0.0;

	switch(adg)
	{
	case 0:
		aa=(float)(addata)*5000.0/(float)ad_unif;//5v
		break;
	case 1:
		aa=(float)(addata)*10000.0/(float)ad_unif;//10v
		break;
	case 2:
		aa=(float)(addata-ad_bipf)*10000.0/(float)ad_bipf;//b10v
		break;
	default:
		aa=(float)(addata)*5000.0/(float)ad_unif;//5v
	}

	return aa;
}

//sort
long sort(long v[],long n)
{
	long i,j,k,t;
	for(i=0;i<n-1;i++)
	{
		k=i;
		for(j=i+1;j<n;j++)
			if(v[j]>v[k])k=j;
			t=v[k];v[k]=v[i];v[i]=t;
	}
	
	return 0;
}

delay_data()
{
	int i,j,k;
	float a,b;

	printf("\nwaiting for delay data.....is.....");

	ftime(&st);

	delay1ms=1001;

	do
	{
		for(i=0;i<10000;i++);

		ftime(&et);
		i=st.time;
		j=st.millitm;
		a=i+(float)j/1000.0;

		i=et.time;
		j=et.millitm;
		b=i+(float)j/1000.0;

		b=b-a;
		delay1ms++;
	}while(b<1.0);

	delay1ms=delay1ms/1000;

	printf("delay data=%ld\n",delay1ms);
}

dl()
{
	int i,j;
	for(i=0;i<6000;i++)
	{
		AP112_inb(hDevice,0x1);
		//if end
		do
		{
			j=AP112_inb(hDevice,0x0) & 1;
		}while(j!=0);
	}
}

//sub function
//inb
long AP112_inb(long hDevice,long adr)
{
	return inp((int)(hDevice+adr));
}

//outb
long AP112_outb(long hDevice,long adr,long iodata)
{
	int i;
	i=iodata & 0xffff;
	outp((int)(hDevice+adr),i);

	return 0;
}
