#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <graph.h>
#include <sys/timeb.h>
#include<sys/types.h>
#include <math.h>

#include "AP112.h"

//must be for AP112

struct timeb st,et;
long delay1ms;

//www.wwlab.com.cn
//2011.12

//iobase
long hDevice=0x320;

void main()
{
	long i,j;

	_clearscreen(_GCLEARSCREEN);
	printf("The AP112 testing program wwlab (c) 2011.12.\n");
	//find AP112
	printf("please set AP112's address 0x320......\n");

	printf("Press any key to continue.\n");

	delay_data();

	//menu
	do
	{
		printf("1.IO test.\n2.CNT test.\n0.exit.\n");
		printf("Please input your sel.....\n");
		i=getch();

		switch(i)
		{
			case '1':
			tsio();break;
			case '2':
			tscnt();break;
			default:
			break;
		}
	}while(i!='0');
}

//*****************************sub function**************************
tsio()
{
	int i;
	
	//clr ap112
	outp(hDevice+0xe,0);
	outp(hDevice+0xf,0);

	_clearscreen(_GCLEARSCREEN);

	//rd state
	i=inp(hDevice+0xe) & 1;
	printf("state:%x\n",i);

	printf("press any key to gen a pulse\n");
	i=getch();

	outp(hDevice+0xe,0x55);
	//delay
	for(i=0;i<30000;i++);
	outp(hDevice+0xe,0xaa);

	//delay
	for(i=0;i<30000;i++);

	//rd state
	i=inp(hDevice+0xe) & 1;
	printf("state:%x\n",i);
}

tscnt()
{
	long i=0;
	long j;

	int ts_sign=0;

	int cntch=0;
	long cwd[2];//write data
	long crd[2];//read cnt data
	long trd[2];//read timer data

	cwd[0]=1100;
	cwd[1]=1200;

#define cts_pn 1000//1000 pulse

	for(cntch=0;cntch<2;cntch++)
	{
		printf("ini ch=%d    ",cntch);
		printf("data=%ld\n",cwd[cntch]);
		AP112_CStart(hDevice,cntch,cwd[cntch]);
	}

	printf("after CNT run and no pulse input ...............\n");

	//read cnt
	for(i=0;i<2;i++)
	{
		AP112_CRead(hDevice,i,&crd[i],&trd[i]);

		if(crd[i]!=cwd[i])
		{
			printf("CH : %d Error!!!No pulse but cnt is run.\n\a",i);
			ts_sign++;
		}
		else
		{
			printf("CH : %d OK!\n",i);
		}
	}

	//pulse
	j=cts_pn;

	printf("***** gen %d pulse *****\n",j);

	for(i=0;i<j;i++)
	{
		outp(hDevice+0xf,0xc0);
		outp(hDevice+0xf,0x0);
	}

	for(i=0;i<2;i++)
	{
		AP112_CRead(hDevice,i,&crd[i],&trd[i]);

		if(crd[i]==0xffffff)
		{
			printf("Error!!! CNT is over......\n\a");
			ts_sign++;
		}
		else
		{
			if(crd[i]==(cwd[i]-cts_pn))
			{
				printf("OK! CH : %d  ",i);
				printf("Read cnt = %ld  ",crd[i]);
				printf("Timer = %ld\n",trd[i]);
			}
			else
			{
				printf("Error Cnt Number!\a  CH : %d  ",i);
				printf("Read cnt = %ld  ",crd[i]);
				printf("Timer = %ld\n",trd[i]);
				ts_sign++;
			}
		}
	}

	if(ts_sign==0)
	{
		printf("Testing All OK!!!\n");
	}
	else
	{
		printf("Testing Error\a!!!\n");
	}
}

//sub function
//stop temp cnt and restart cnt and setting cnt data
//cdata:24bit data from 0-ffffffh
long AP112_CStart(long hDevice,long cntch,long cdata)
{	
	long i;

	//stop
	i=stop_cnt(hDevice,cntch);
	if(i<0)
		return -1;

	//initial data
	wr_cnt(hDevice,cntch,cdata);

	//run
	return run_cnt(hDevice,cntch);
}

//read cnt
//cnt channel:cntch
//*cdata:cnt data
//*tdata:timer's data
//return : =0 ok / =1 cnt is over
long AP112_CRead(long hDevice,long cntch,long *cdata,long *tdata)
{
	long i;

	cntch=cntch & 1;//=0 or 1

	//read data
	i=rd_cnt(hDevice,cntch,cdata,tdata);
	if(i<0)
		return -1;

	i=inp(hDevice+0xb);
	i=i>>cntch;
	i=i & 1;

	if(i!=0)
		return 1;//cnt over

	return 0;
}

//cnt sub function

//run cnt
long run_cnt(long hDevice,long cntch)
{
	long cop=0;
	long cop1=0;
	cop1=cntch<<4;

	cop=cop1 | 0x0;//load data to buffer

	return outp(hDevice+0xb,cop);
}

//stop cnt
long stop_cnt(long hDevice,long cntch)
{
	long cop=0;
	long cop1=0;

	cop1=cntch<<4;

	cop=cop1 | 0x1;

	return outp(hDevice+0xb,cop);
}

//wr cnt
long wr_cnt(long hDevice,long cntch,long cdata)
{
	long cop=0;
	long cop1=0;
	long i=0;

	i=outp(hDevice+0x8,(cdata & 0xff));
	if(i<0)
		return -1;

	cdata=cdata >> 8;
	outp(hDevice+0x9,(cdata & 0xff));

	cdata=cdata >> 8;
	outp(hDevice+0xa,(cdata & 0xff));

	cop1=cntch<<4;

	cop=cop1 | 0x2;

	outp(hDevice+0xb,cop);

	return 0;
}

//read cnt
long rd_cnt(long hDevice,long cntch,long *cdata,long *tdata)
{
	long cop=0;
	long cop1=0;
	long i=0;

	cop1=cntch<<4;

	//load cdata
	cop=cop1 | 0x4;
	i=outp(hDevice+0xb,cop);

	if(i<0)
		return -1;

	//read h
	i=inp(hDevice+0xa) & 0xff;
	i=i<<8;

	//read m
	i=i | (inp(hDevice+0x9) & 0xff);
	i=i<<8;

	//read l
	*cdata=i | (inp(hDevice+0x8) & 0xff);

	//load tdata
	cop=cop1 | 0x5;
	outp(hDevice+0xb,cop);

	//read h
	i=inp(hDevice+0xa) & 0xff;
	i=i<<8;

	//read m
	i=i | (inp(hDevice+0x9) & 0xff);
	i=i<<8;

	//read l
	*tdata=i | (inp(hDevice+0x8) & 0xff);

	return 0;
}

delay_data()
{
	int i,j,k;
	float a,b;

	printf("\nwaiting for delay data.....is.....");

	ftime(&st);

	delay1ms=1001;

	do
	{
		for(i=0;i<10000;i++);

		ftime(&et);
		i=st.time;
		j=st.millitm;
		a=i+(float)j/1000.0;

		i=et.time;
		j=et.millitm;
		b=i+(float)j/1000.0;

		b=b-a;
		delay1ms++;
	}while(b<1.0);

	delay1ms=delay1ms/1000;

	printf("delay data=%ld\n",delay1ms);
}
